/******************************************************************************/
/* nullable.jison                                                             */
/******************************************************************************/
%lex

letter [$A-Za-z_]

%%

{letter}(?:{letter}|[0-9])* return 'IDENTIFIER';
[1-9][0-9]*                 return 'NUMBER';
"signed"                    return 'SIGNED';
"synchronized"              return 'SYNCHRONIZED';
"{"                         return '{';
"}"                         return '}';
"["                         return '[';
"]"                         return ']';
";"                         return ';';

/lex

%start program

%%

program
    : defn ";"
    ;

defn
    : typedecl more
    ;

typedecl
    : IDENTIFIER
    ;

more
    : "("
    | evenmore
    ;

evenmore
    : derefs
    ;

derefs
    :
    | derefs "["
    ;
